Index: /trunk/LMDZ.COMMON/libf/evolution/abort_pem_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/abort_pem_mod.F90	(revision 3076)
+++ /trunk/LMDZ.COMMON/libf/evolution/abort_pem_mod.F90	(revision 3076)
@@ -0,0 +1,59 @@
+MODULE abort_pem_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE abort_pem(modname,message,ierr)
+
+#ifdef CPP_IOIPSL
+    use IOIPSL
+#else
+    ! if not using IOIPSL, we still need to use (a local version of) getin_dump
+    use ioipsl_getincom
+#endif
+
+#ifdef CPP_XIOS
+    use wxios ! ug Pour les sorties XIOS
+#endif
+
+implicit none
+
+#include "iniprint.h"
+
+! Stop the simulation cleanly, closing files and printing various comments
+! Input: modname = name of calling program
+!        message = stuff to print
+!        ierr    = severity of situation (= 0 normal)
+character(len = *), intent(in) :: modname
+integer,            intent(in) :: ierr
+character(len = *), intent(in) :: message
+
+!----- Code
+write(lunout,*) 'in abort_pem'
+
+#ifdef CPP_XIOS
+    CALL wxios_close() ! Fermeture propre de XIOS
+#endif
+
+#ifdef CPP_IOIPSL
+    call histclo
+    call restclo
+#endif
+
+call getin_dump
+write(lunout,*) 'Stopping in ', modname
+write(lunout,*) 'Reason = ', message
+if (ierr == 0) then
+    write(lunout,*) 'Everything is cool'
+    stop
+else
+    write(lunout,*) 'Houston, we have a problem ', ierr
+    stop 1
+endif
+
+END SUBROUTINE abort_pem
+
+END MODULE abort_pem_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_slope_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_slope_mod.F90	(revision 3076)
+++ /trunk/LMDZ.COMMON/libf/evolution/compute_tendencies_slope_mod.F90	(revision 3076)
@@ -0,0 +1,39 @@
+MODULE compute_tendencies_slope_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE compute_tendencies_slope(ngrid,nslope,min_ice_Y1,min_ice_Y2,tendencies_ice)
+
+implicit none
+
+!=======================================================================
+!
+!  Compute the tendencies of the evolution of water ice over the years
+!
+!=======================================================================
+
+!   arguments:
+!   ----------
+!   INPUT
+integer,                       intent(in) :: ngrid, nslope ! # of grid points along longitude/latitude/ total
+real, dimension(ngrid,nslope), intent(in) :: min_ice_Y1    ! LON x LAT field : minimum of water ice at each point for the first year
+real, dimension(ngrid,nslope), intent(in) :: min_ice_Y2    ! LON x LAT field : minimum of water ice at each point for the second year
+
+!   OUTPUT
+real, dimension(ngrid,nslope), intent(out) :: tendencies_ice ! physical point field : difference between the minima = evolution of perenial ice
+!=======================================================================
+
+!  We compute the difference
+tendencies_ice = min_ice_Y2 - min_ice_Y1
+
+!  If the difference is too small; there is no evolution
+where (abs(tendencies_ice) < 1.e-10) tendencies_ice = 0.
+
+END SUBROUTINE compute_tendencies_slope
+
+END MODULE compute_tendencies_slope_mod
+
Index: /trunk/LMDZ.COMMON/libf/evolution/conf_pem.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/conf_pem.F90	(revision 3075)
+++ /trunk/LMDZ.COMMON/libf/evolution/conf_pem.F90	(revision 3076)
@@ -8,29 +8,33 @@
 !=======================================================================
 
-IMPLICIT NONE
+implicit none
 
-CONTAINS
+!=======================================================================
+contains
+!=======================================================================
 
-  SUBROUTINE conf_pem(i_myear,n_myears)
+SUBROUTINE conf_pem(i_myear,n_myears)
 
 #ifdef CPP_IOIPSL
-  use IOIPSL, only: getin
+    use IOIPSL,          only: getin
 #else
-  ! if not using IOIPSL, we still need to use (a local version of) getin
-  use ioipsl_getincom, only: getin
+    ! if not using IOIPSL, we still need to use (a local version of) getin
+    use ioipsl_getincom, only: getin
 #endif
-  
-  use time_evol_mod,  only: year_bp_ini, dt_pem, water_ice_criterion, co2_ice_criterion, ps_criterion, Max_iter_pem, &
-                            evol_orbit_pem, var_obl, var_ecc, var_lsp, convert_years
-  use comsoil_h_pem,  only: soil_pem, fluxgeo, water_reservoir_nom, depth_breccia, depth_bedrock, reg_thprop_dependp 
-  use adsorption_mod, only: adsorption_pem
-  use glaciers_mod,   only: co2glaciersflow, h2oglaciersflow
-  use ice_table_mod,  only: icetable_equilibrium, icetable_dynamic 
 
-  integer, intent(out) :: i_myear, n_myears ! Current simulated Martian year and maximum number of Martian years to be simulated
+use time_evol_mod,  only: year_bp_ini, dt_pem, water_ice_criterion, co2_ice_criterion, ps_criterion, Max_iter_pem, &
+                          evol_orbit_pem, var_obl, var_ecc, var_lsp, convert_years
+use comsoil_h_pem,  only: soil_pem, fluxgeo, water_reservoir_nom, depth_breccia, depth_bedrock, reg_thprop_dependp
+use adsorption_mod, only: adsorption_pem
+use glaciers_mod,   only: co2glaciersflow, h2oglaciersflow
+use ice_table_mod,  only: icetable_equilibrium, icetable_dynamic
 
-  character(len=20), parameter :: modname ='conf_pem'
-  integer                      :: ierr
-  integer                      :: year_earth_bp_ini ! Initial year (in Earth years) of the simulation of the PEM defined in run.def
+implicit none
+
+integer, intent(out) :: i_myear, n_myears ! Current simulated Martian year and maximum number of Martian years to be simulated
+
+character(20), parameter :: modname ='conf_pem'
+integer                  :: ierr
+integer                  :: year_earth_bp_ini ! Initial year (in Earth years) of the simulation of the PEM defined in run.def
 
 !PEM parameters
@@ -48,106 +52,106 @@
 
 ! #---------- Orbital parameters
-  evol_orbit_pem=.false.
-  call getin('evol_orbit_pem',evol_orbit_pem)
+evol_orbit_pem = .false.
+call getin('evol_orbit_pem',evol_orbit_pem)
 
-  year_bp_ini = 0.
-  call getin('year_earth_bp_ini',year_earth_bp_ini)
-  year_bp_ini = year_earth_bp_ini/convert_years
+year_bp_ini = 0.
+call getin('year_earth_bp_ini',year_earth_bp_ini)
+year_bp_ini = year_earth_bp_ini/convert_years
 
-  var_obl = .true.
-  call getin('var_obl',var_obl)
-  write(*,*) 'Does obliquity vary ?',var_obl
+var_obl = .true.
+call getin('var_obl',var_obl)
+write(*,*) 'Does obliquity vary ?',var_obl
 
-  var_ecc = .true.
-  call getin('var_ecc',var_ecc)
-  write(*,*) 'Does excentricity vary ?',var_ecc
+var_ecc = .true.
+call getin('var_ecc',var_ecc)
+write(*,*) 'Does excentricity vary ?',var_ecc
 
-  var_lsp = .true.
-  call getin('var_lsp',var_lsp)
-  write(*,*) 'Does Ls peri vary ?',var_lsp
+var_lsp = .true.
+call getin('var_lsp',var_lsp)
+write(*,*) 'Does Ls peri vary ?',var_lsp
 
 ! #---------- Stopping criteria parameters
-  Max_iter_pem=100000000
-  call getin('Max_iter_pem', Max_iter_pem)
+Max_iter_pem = 100000000
+call getin('Max_iter_pem',Max_iter_pem)
 
-  water_ice_criterion=0.2
-  call getin('water_ice_criterion', water_ice_criterion)
+water_ice_criterion = 0.2
+call getin('water_ice_criterion',water_ice_criterion)
 
-  co2_ice_criterion=0.2
-  call getin('co2_ice_criterion', co2_ice_criterion)
+co2_ice_criterion = 0.2
+call getin('co2_ice_criterion',co2_ice_criterion)
 
-  ps_criterion = 0.15
-  call getin('ps_criterion',ps_criterion)
+ps_criterion = 0.15
+call getin('ps_criterion',ps_criterion)
 
-  dt_pem=1
-  call getin('dt_pem', dt_pem)
+dt_pem = 1
+call getin('dt_pem', dt_pem)
 
 ! #---------- Subsurface parameters
-  soil_pem=.true.
-  call getin('soil_pem', soil_pem)
+soil_pem = .true.
+call getin('soil_pem',soil_pem)
 
-  adsorption_pem = .true.
-  call getin('adsorption_pem',adsorption_pem)
+adsorption_pem = .true.
+call getin('adsorption_pem',adsorption_pem)
 
-  co2glaciersflow = .true.
-  call getin('co2glaciersflow', co2glaciersflow)
+co2glaciersflow = .true.
+call getin('co2glaciersflow',co2glaciersflow)
 
-  h2oglaciersflow = .true.
-  call getin('h2oglaciersflow', h2oglaciersflow)
+h2oglaciersflow = .true.
+call getin('h2oglaciersflow',h2oglaciersflow)
 
-  reg_thprop_dependp = .false.
-  call getin('reg_thprop_dependp',reg_thprop_dependp)
-  write(*,*)  'Thermal properties of the regolith vary with pressure ?', reg_thprop_dependp
+reg_thprop_dependp = .false.
+call getin('reg_thprop_dependp',reg_thprop_dependp)
+write(*,*)  'Thermal properties of the regolith vary with pressure ?', reg_thprop_dependp
 
 ! #---------- Layering parameters
-  fluxgeo = 0.
-  call getin('fluxgeo',fluxgeo)
-  write(*,*) 'Flux Geothermal is set to',fluxgeo
-   
-  depth_breccia   = 10.
-  call getin('depth_breccia',depth_breccia)
-  write(*,*) 'Depth of breccia is set to',depth_breccia
+fluxgeo = 0.
+call getin('fluxgeo',fluxgeo)
+write(*,*) 'Flux Geothermal is set to',fluxgeo
 
-  depth_bedrock   = 1000.
-  call getin('depth_bedrock',depth_bedrock)
-  write(*,*) 'Depth of bedrock is set to',depth_bedrock
+depth_breccia = 10.
+call getin('depth_breccia',depth_breccia)
+write(*,*) 'Depth of breccia is set to',depth_breccia
 
-   icetable_equilibrium = .true.
-   call getin('icetable_equilibrium',icetable_equilibrium)
-   write(*,*)  'Is the ice table computed at equilibrium?', icetable_equilibrium
+depth_bedrock = 1000.
+call getin('depth_bedrock',depth_bedrock)
+write(*,*) 'Depth of bedrock is set to',depth_bedrock
 
-   icetable_dynamic = .false.
-   call getin('icetable_dynamic',icetable_dynamic)
-   write(*,*)  'Is the ice table computed with the dynamic method?', icetable_dynamic
-  if ((.not.soil_pem).and.((icetable_equilibrium).or.(icetable_dynamic))) then
-       write(*,*) 'Ice table  must be used when soil_pem = T'
-       call abort_physic(modname,"Ice table  must be used when soil_pem = T",1)
-  endif
+icetable_equilibrium = .true.
+call getin('icetable_equilibrium',icetable_equilibrium)
+write(*,*)  'Is the ice table computed at equilibrium?', icetable_equilibrium
 
-  if ((.not.soil_pem).and.adsorption_pem) then
-       write(*,*) 'Adsorption must be used when soil_pem = T'
-       call abort_physic(modname,"Adsorption must be used when soil_pem = T",1)
-  endif
-  
-  if ((.not.soil_pem).and.(fluxgeo.gt.0.)) then
-       write(*,*) 'Soil is not activated but Flux Geo > 0.'
-       call abort_physic(modname,"Soil is not activated but Flux Geo > 0.",1)
-  endif
- 
-  if ((.not.soil_pem).and.reg_thprop_dependp) then
-     write(*,*) 'Regolith properties vary with Ps only when soil is set to true'
-     call abort_physic(modname,'Regolith properties vary with Ps only when soil is set to true',1)
-  endif
+icetable_dynamic = .false.
+call getin('icetable_dynamic',icetable_dynamic)
+write(*,*)  'Is the ice table computed with the dynamic method?', icetable_dynamic
+if ((.not. soil_pem) .and. ((icetable_equilibrium) .or. (icetable_dynamic))) then
+    write(*,*) 'Ice table  must be used when soil_pem = T'
+    call abort_physic(modname,"Ice table  must be used when soil_pem = T",1)
+endif
 
-  if (evol_orbit_pem .and. year_bp_ini == 0.) then
-     write(*,*)  'You want to follow the file obl_ecc_lsp.asc for changing orb parameters,'
-     write(*,*)  'but you did not specify from which year to start.'
-     call abort_physic(modname,"evol_orbit_pem=.true. but year_bp_ini=0",1)
-  endif 
+if ((.not. soil_pem) .and. adsorption_pem) then
+    write(*,*) 'Adsorption must be used when soil_pem = T'
+    call abort_physic(modname,"Adsorption must be used when soil_pem = T",1)
+endif
 
-  water_reservoir_nom = 1e4
-  call getin('water_reservoir_nom',water_reservoir_nom)
+if ((.not. soil_pem) .and. (fluxgeo > 0.)) then
+    write(*,*) 'Soil is not activated but Flux Geo > 0.'
+    call abort_physic(modname,"Soil is not activated but Flux Geo > 0.",1)
+endif
 
-  END SUBROUTINE conf_pem
+if ((.not. soil_pem) .and. reg_thprop_dependp) then
+    write(*,*) 'Regolith properties vary with Ps only when soil is set to true'
+    call abort_physic(modname,'Regolith properties vary with Ps only when soil is set to true',1)
+endif
+
+if (evol_orbit_pem .and. year_bp_ini == 0.) then
+    write(*,*)  'You want to follow the file obl_ecc_lsp.asc for changing orb parameters,'
+    write(*,*)  'but you did not specify from which year to start.'
+    call abort_physic(modname,"evol_orbit_pem=.true. but year_bp_ini=0",1)
+endif
+
+water_reservoir_nom = 1.e4
+call getin('water_reservoir_nom',water_reservoir_nom)
+
+END SUBROUTINE conf_pem
 
 END MODULE conf_pem_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/constants_marspem_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/constants_marspem_mod.F90	(revision 3075)
+++ /trunk/LMDZ.COMMON/libf/evolution/constants_marspem_mod.F90	(revision 3076)
@@ -1,46 +1,44 @@
-    MODULE constants_marspem_mod
+MODULE constants_marspem_mod
 
+implicit none
 
-    IMPLICIT NONE
 ! Duration of a year and day 
-      INTEGER,PARAMETER :: sols_per_my =669 ! Number of Sols per year
-      REAL, PARAMETER :: sec_per_sol=88775.  ! Duration of a sol, in seconds
+integer, parameter :: sols_per_my = 669    ! Number of Sols per year
+real,    parameter :: sec_per_sol = 88775. ! Duration of a sol, in seconds
 
 ! Molecular masses for CO2,H2O and non condensible gaz, following Franz et al. 2017    
-      REAL,PARAMETER :: m_co2 = 44.01E-3  ! CO2 molecular mass (kg/mol)   
-      REAL,PARAMETER :: m_noco2 = 33.37E-3  ! Non condensible mol mass (kg/mol)   
-      REAL,PARAMETER :: m_h2o = 18.01528E-3      ! Molecular weight of h2o (kg/mol)
+real, parameter :: m_co2 = 44.01e-3    ! CO2 molecular mass (kg/mol)   
+real, parameter :: m_noco2 = 33.37e-3  ! Non condensible mol mass (kg/mol)   
+real, parameter :: m_h2o = 18.01528e-3 ! Molecular weight of h2o (kg/mol)
 
 !     Coefficient for Clapeyron law for CO2 condensation temperature (Tco2 = beta/(alpha-log(vmr)),following James et al. 1992
-      REAL,PARAMETER :: alpha_clap_co2 = 23.3494  !Uniteless,James et al. 1992
-      REAL,PARAMETER :: beta_clap_co2 = 3182.48   !Kelvin, James et al. 1992
+real, parameter :: alpha_clap_co2 = 23.3494 ! Uniteless, James et al. 1992
+real, parameter :: beta_clap_co2 = 3182.48  ! Kelvin, James et al. 1992
 
 !     Coefficient for Clapeyron law for psat (psat = exp(beta/Th2o+alpha)),following Murphy and Koop 2005
-      REAL,PARAMETER :: alpha_clap_h2o = 28.9074  ! Uniteless, Murphy and Koop 2005
-      REAL,PARAMETER :: beta_clap_h2o = -6143.7   ! Kelvin, Murphy and Koop 2005
+real, parameter :: alpha_clap_h2o = 28.9074 ! Uniteless, Murphy and Koop 2005
+real, parameter :: beta_clap_h2o = -6143.7  ! Kelvin, Murphy and Koop 2005
 
 !     Density of the regolith (Zent et al., 1995, Buhler and Piqueux 2021)     
-      REAL,PARAMETER ::  rho_regolith = 2000.     ! kg/m^3
+real, parameter :: rho_regolith = 2000. ! kg/m^3
 
 !     Average  Thermal inertia of the surface, breccia, bedrock, following Mellon et al., 2000., Wood et al., 2008
-      REAL,PARAMETER :: TI_regolith_avg = 250.        ! Averaged of the observed thermal inertia for regolith following Mellon et al., 2000[SI]
-      REAL,PARAMETER :: TI_breccia = 750.             ! Thermal inertia of Breccia following Wood 2009 [SI]
-      REAL,PARAMETER :: TI_bedrock = 2300.            ! Thermal inertia of Bedrock following Wood 2009 [SI]
+real, parameter :: TI_regolith_avg = 250. ! Averaged of the observed thermal inertia for regolith following Mellon et al., 2000[SI]
+real, parameter :: TI_breccia = 750.      ! Thermal inertia of Breccia following Wood 2009 [SI]
+real, parameter :: TI_bedrock = 2300.     ! Thermal inertia of Bedrock following Wood 2009 [SI]
 
 !     Porosity of the soil
-      REAL,PARAMETER :: porosity = 0.4                ! porosity of the martian soil, correspond to the value for a random loose packing of monodiperse sphere (Scott, 1960)
+real, parameter :: porosity = 0.4 ! porosity of the martian soil, correspond to the value for a random loose packing of monodiperse sphere (Scott, 1960)
 
 !     Stefan Boltzmann constant
-      REAL,PARAMETER :: sigmaB=5.678E-8 
+real, parameter :: sigmaB = 5.678e-8 
 
 !     Latent heat of CO2
-      REAL,PARAMETER ::  Lco2 =  5.71E5                ! Pilorget and Forget 2016
+real, parameter :: Lco2 =  5.71e5 ! Pilorget and Forget 2016
 
 ! Conversion H2O/CO2 frost to perenial frost and vice versa
-      REAL,PARAMETER :: threshold_water_frost2perenial = 1000. !~ 1m
-      REAL,PARAMETER :: threshold_co2_frost2perenial = 3200.   !~ 2m
+real, parameter :: threshold_water_frost2perenial = 1000. !~ 1m
+real, parameter :: threshold_co2_frost2perenial = 3200.   !~ 2m
 
+END MODULE constants_marspem_mod
 
-      
-    END MODULE constants_marspem_mod
-
Index: /trunk/LMDZ.COMMON/libf/evolution/glaciers_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/glaciers_mod.F90	(revision 3075)
+++ /trunk/LMDZ.COMMON/libf/evolution/glaciers_mod.F90	(revision 3076)
@@ -26,5 +26,4 @@
 !!!
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
 
 IMPLICIT NONE
@@ -105,5 +104,6 @@
 subroutine compute_hmaxglaciers(ngrid,nslope,iflat,def_slope_mean,Tice,name_ice,hmax)
 
-     USE comconst_mod, ONLY: pi,g
+use comconst_mod,  only: pi,g
+use abort_pem_mod, only: abort_pem
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -181,5 +181,6 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-      USE comconst_mod, ONLY: pi
+use comconst_mod,  only: pi
+use abort_pem_mod, only: abort_pem
 
 
Index: /trunk/LMDZ.COMMON/libf/evolution/info_run_PEM_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/info_run_PEM_mod.F90	(revision 3076)
+++ /trunk/LMDZ.COMMON/libf/evolution/info_run_PEM_mod.F90	(revision 3076)
@@ -0,0 +1,46 @@
+MODULE info_run_PEM_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE info_run_PEM(year_iter,criterion_stop,i_myear,n_myear)
+
+!=======================================================================
+!
+! Purpose: Write in a file called info_run_PEM.txt the reason why the PEM did stop and the number of extrapolation year done
+!          Update the file tmp_PEMyears.txt to count the number of simulated Martian years
+!
+! Author: RV, JBC
+!=======================================================================
+
+use time_evol_mod, only: convert_years
+
+implicit none
+
+!----- Arguments
+integer, intent(in) :: year_iter, criterion_stop ! # of year and reason to stop
+integer, intent(in) :: i_myear, n_myear          ! Current simulated Martian year and maximum number of Martian years to be simulated
+
+!----- Local variables
+logical :: ok
+
+!----- Code
+inquire(file = 'info_run_PEM.txt', exist = ok)
+if (ok) then
+    open(12,file = 'info_run_PEM.txt',status = "old",position = "append",action = "write")
+else
+    open(12,file = 'info_run_PEM.txt',status = "new",action = "write")
+endif
+write(12,*) year_iter, i_myear, criterion_stop
+close(12)
+
+open(100,file = 'tmp_PEMyears.txt',status = 'replace')
+write(100,*) i_myear, n_myear, convert_years
+close(100)
+
+END SUBROUTINE info_run_PEM
+
+END MODULE info_run_PEM_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/interpolate_TIPEM_TIGCM_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/interpolate_TIPEM_TIGCM_mod.F90	(revision 3076)
+++ /trunk/LMDZ.COMMON/libf/evolution/interpolate_TIPEM_TIGCM_mod.F90	(revision 3076)
@@ -0,0 +1,39 @@
+MODULE interpolate_TIPEM_TIGCM_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE interpolate_TIPEM_TIGCM(ngrid,nslope,nsoil_PEM,nsoil_GCM,TI_PEM,TI_GCM)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!
+!!! Purpose: Transfer the thermal inertia from the PEM vertical  grid to the GCM vertical grid
+!!!
+!!!
+!!! Author: LL
+!!!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+implicit none
+
+!======================================================================
+!  arguments
+!  ---------
+!  inputs:
+integer,                                 intent(in) :: ngrid     ! # of horizontal grid points
+integer,                                 intent(in) :: nslope    ! # of subslope wihtin the mesh
+integer,                                 intent(in) :: nsoil_PEM ! # of soil layers in the PEM
+integer,                                 intent(in) :: nsoil_GCM ! # of soil layers in the GCM
+real, dimension(ngrid,nsoil_PEM,nslope), intent(in) :: TI_PEM    ! Thermal inertia in the PEM vertical grid [J/m^2/K/s^{1/2}]
+
+real, dimension(ngrid,nsoil_GCM,nslope), intent(inout) :: TI_GCM ! Thermal inertia in the GCM vertical grid [J/m^2/K/s^{1/2}]
+
+!----- Code
+TI_GCM(:,:,:) = TI_PEM(:,:nsoil_GCM,:)
+
+END SUBROUTINE interpolate_TIPEM_TIGCM
+
+END MODULE interpolate_TIPEM_TIGCM_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/lask_param_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/lask_param_mod.F90	(revision 3075)
+++ /trunk/LMDZ.COMMON/libf/evolution/lask_param_mod.F90	(revision 3076)
@@ -1,7 +1,8 @@
-module lask_param_mod
+MODULE lask_param_mod
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !!!
 !!! Purpose: Define parameters from Laskar et al., 2004 evolution
-!!! 
+!!!
 !!! Author: RV, JBC
 !!!
@@ -10,45 +11,45 @@
 implicit none
 
-  real,save,allocatable :: yearlask(:) ! year before present from Laskar et al. Tab
-  real,save,allocatable :: obllask(:)  ! obliquity    [deg]
-  real,save,allocatable :: ecclask(:)  ! excentricity [deg]
-  real,save,allocatable :: lsplask(:)  ! ls perihelie [deg]
-  integer, save         :: last_ilask  ! Index of the line in the file year_obl_lask.asc corresponding to the closest lower year to the current year
+real, dimension(:), allocatable, save :: yearlask   ! year before present from Laskar et al. Tab
+real, dimension(:), allocatable, save :: obllask    ! obliquity    [deg]
+real, dimension(:), allocatable, save :: ecclask    ! excentricity [deg]
+real, dimension(:), allocatable, save :: lsplask    ! ls perihelie [deg]
+integer,                         save :: last_ilask ! Index of the line in the file year_obl_lask.asc corresponding to the closest lower year to the current year
 
+!=======================================================================
 contains
+!=======================================================================
 
-  subroutine ini_lask_param_mod
-  
-  implicit none
+SUBROUTINE ini_lask_param_mod
 
-  integer :: nlask ! number of lines in Laskar files
-  integer :: ierr
+implicit none
 
-  nlask = 0
-  open(1,file = 'obl_ecc_lsp.asc')
-  do
-      read(1,*,iostat = ierr)
-      if (ierr /= 0) exit
-      nlask = nlask + 1
-  enddo
-  close(1)
-  allocate(yearlask(nlask))
-  allocate(obllask(nlask))
-  allocate(ecclask(nlask))
-  allocate(lsplask(nlask))
-  
-  end subroutine ini_lask_param_mod
+integer :: nlask ! number of lines in Laskar files
+integer :: ierr
 
+nlask = 0
+open(1,file = 'obl_ecc_lsp.asc')
+do
+    read(1,*,iostat = ierr)
+    if (ierr /= 0) exit
+    nlask = nlask + 1
+enddo
+close(1)
+allocate(yearlask(nlask),obllask(nlask),ecclask(nlask),lsplask(nlask))
 
-  subroutine end_lask_param_mod
+END SUBROUTINE ini_lask_param_mod
 
-  implicit none
+!=======================================================================
 
-  if (allocated(yearlask)) deallocate(yearlask)
-  if (allocated(obllask)) deallocate(obllask)
-  if (allocated(ecclask)) deallocate(ecclask)
-  if (allocated(lsplask)) deallocate(lsplask)
+SUBROUTINE end_lask_param_mod
 
-  end subroutine end_lask_param_mod
-  
-end module lask_param_mod
+implicit none
+
+if (allocated(yearlask)) deallocate(yearlask)
+if (allocated(obllask)) deallocate(obllask)
+if (allocated(ecclask)) deallocate(ecclask)
+if (allocated(lsplask)) deallocate(lsplask)
+
+END SUBROUTINE end_lask_param_mod
+
+END MODULE lask_param_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/nb_time_step_GCM_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/nb_time_step_GCM_mod.F90	(revision 3076)
+++ /trunk/LMDZ.COMMON/libf/evolution/nb_time_step_GCM_mod.F90	(revision 3076)
@@ -0,0 +1,100 @@
+MODULE nb_time_step_GCM_mod
+
+use netcdf, only: nf90_open, NF90_NOWRITE, nf90_noerr, nf90_strerror, &
+                  nf90_get_var, nf90_inq_varid, nf90_inq_dimid,       &
+                  nf90_inquire_dimension, nf90_close
+
+implicit none
+
+character(256) :: msg, var, modname
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE nb_time_step_GCM(fichnom,timelen)
+
+implicit none
+
+!=======================================================================
+!
+! Purpose: Read in the data_GCM_Yr*.nc the number of time step
+!
+! Author: RV
+!=======================================================================
+
+include "dimensions.h"
+
+!=======================================================================
+! Arguments:
+character(len = *), intent(in) :: fichnom !--- FILE NAME
+!=======================================================================
+!   Local Variables
+integer        :: iq, fID, vID, idecal, ierr
+integer        :: timelen ! number of times stored in the file
+!-----------------------------------------------------------------------
+modname = "nb_time_step_GCM"
+
+!  Open initial state NetCDF file
+var = fichnom
+call error_msg(NF90_OPEN(var,NF90_NOWRITE,fID),"open",var)
+
+ierr = nf90_inq_varid (fID, "temps", vID)
+if (ierr /= nf90_noerr) then
+    write(*,*)"read_data_GCM: Le champ <temps> est absent"
+    write(*,*)"read_data_GCM: J essaie <time_counter>"
+    ierr = nf90_inq_varid (fID, "time_counter", vID)
+    if (ierr /= nf90_noerr) then
+        write(*,*)"read_data_GCM: Le champ <time_counter> est absent"
+        write(*,*)"read_data_GCM: J essaie <Time>"
+        ierr = nf90_inq_varid (fID, "Time", vID)
+        if (ierr /= nf90_noerr) then
+            write(*,*)"read_data_GCM: Le champ <Time> est absent"
+            write(*,*)trim(nf90_strerror(ierr))
+            call abort_gcm("nb_time_step_GCM", "", 1)
+        endif
+        ! Get the length of the "Time" dimension
+        ierr = nf90_inq_dimid(fID,"Time",vID)
+        ierr = nf90_inquire_dimension(fID,vID,len = timelen)
+    else
+        ! Get the length of the "time_counter" dimension
+        ierr = nf90_inq_dimid(fID,"time_counter",vID)
+        ierr = nf90_inquire_dimension(fID,vID,len = timelen)
+    endif
+else
+    ! Get the length of the "temps" dimension
+    ierr = nf90_inq_dimid(fID,"temps",vID)
+    ierr = nf90_inquire_dimension(fID,vID,len = timelen)
+endif
+
+call error_msg(NF90_CLOSE(fID),"close",fichnom)
+
+write(*,*) "The number of timestep of the PCM run data=", timelen
+
+END SUBROUTINE nb_time_step_GCM
+
+!=======================================================================
+
+SUBROUTINE error_msg(ierr,typ,nam)
+
+implicit none
+
+integer,            intent(in) :: ierr !--- NetCDF ERROR CODE
+character(len = *), intent(in) :: typ  !--- TYPE OF OPERATION
+character(len = *), intent(in) :: nam  !--- FIELD/FILE NAME
+
+if (ierr == nf90_noerr) return
+select case(typ)
+    case('inq');   msg = "Field <"//trim(nam)//"> is missing"
+    case('get');   msg = "Reading failed for <"//trim(nam)//">"
+    case('open');  msg = "File opening failed for <"//trim(nam)//">"
+    case('close'); msg = "File closing failed for <"//trim(nam)//">"
+    case default
+        write(*,*) 'There is no message for this error.'
+        error stop
+end select
+call abort_gcm(trim(modname),trim(msg),ierr)
+
+END SUBROUTINE error_msg
+
+END MODULE nb_time_step_GCM_mod
